#!/usr/bin/python

# anilines.py
import sys

def getSymbols(array):
        ret = []
        for elem in array:
                ret.append(elem[0])
        return ret

def getChildren(array):
	ret = []
	for elem in array:
		ret += elem[2]
	return ret

line_number = 0
elements_length = 0
bond_count = 0
elements = []

sdfile = open(sys.argv[1])

for line in sdfile:
	line_number += 1
	
	if line_number == 4:
		elements_length = int(line.split()[0])
		bond_count = int(line.split()[1])
	
	elif line_number > 4 and line_number - 5 < elements_length:
		elements.append([line.split()[3], line_number - 4, []])	
	
	elif line_number - 5 < elements_length + bond_count and line_number > 4:
		elements[int(line.split()[0]) - 1][2] += [elements[int(line.split()[1]) - 1]]
		elements[int(line.split()[1]) - 1][2] += [elements[int(line.split()[0]) - 1]]

sdfile.close()

#print "--------"
#for elem in elements:
#	print elem[0] + ' ' + str(getSymbols(elem[2]))
#print "--------"

hydrogen1 = 0
hydrogen2 = 0
carbon = 0
nitrogen = 0

ortho_substitued = False

for element in elements:
	if element[0] == 'C' and sorted(getSymbols(element[2])) == ['C','C','N']:
		for s1 in element[2]:
			if s1[0] == 'N' and sorted(getSymbols(s1[2])) == ['C', 'H', 'H']:
				for s2 in s1[2]:
                                        if s2[0] == 'C':
                                                carbon = s2[1]
                                        elif s2[0] == 'H':
                                                if hydrogen1 == 0:
                                                        hydrogen1 = s2[1]
                                                else:
                                                        hydrogen2 = s2[1]
                                nitrogen = s1[1]
				if sorted(getSymbols(getChildren(element[2]))) != ['C','C','C','C','C','H','H','H','H']:
					ortho_substitued = True
							
print str(carbon) + ';' + str(nitrogen) + ';' + str(hydrogen1) + ';' + str(hydrogen2) + ';' + str(int(ortho_substitued))
