#!/usr/bin/perl -w
use Getopt::Std;

getopt("i:");

if(! $opt_i){
	$opt_i = "test";
}

print '
file="'.$opt_i.'";
file_input = paste(file,".csv",sep="");
file_out = paste(file,".predict",sep="");
file_csv <- read.csv( file=file_input,TRUE,";","");
NSC = c(); H1 = c(); N = c(); C1 = c(); pka = c(); H2 = c();
number=length(row.names(file_csv));
for(i in 1:number ) {
	NSC[i]=file_csv[i,1];
	pka[i]=file_csv[i,3];
	C1[i]=file_csv[i,5];
	N[i]=file_csv[i,7];
	H1[i]=file_csv[i,9];
	H2[i]=file_csv[i,11]
}

regress = lm(pka~C1+N+H1+H2);

summary(regress);

infl = influence.measures(regress);
#infl

predict_pka = data.frame(predict(regress));
plot(predict(regress), pka, pch=16, col = "green3");

#new
write.csv(predict_pka,file=file_out);

rmse = sqrt(mean((pka-predict(regress))^2));
rmse

';
